// Copyright (C) 2018-2019  Nexedi SA and Contributors.
//                          Kirill Smelkov <kirr@nexedi.com>
//
// This program is free software: you can Use, Study, Modify and Redistribute
// it under the terms of the GNU General Public License version 3, or (at your
// option) any later version, as published by the Free Software Foundation.
//
// You can also Link and Combine this program with other software covered by
// the terms of any of the Free Software licenses or any of the Open Source
// Initiative approved licenses and Convey the resulting work. Corresponding
// source of such a combination shall include the source code for all other
// software used.
//
// This program is distributed WITHOUT ANY WARRANTY; without even the implied
// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
// See COPYING file for full licensing terms.
// See https://www.nexedi.com/licensing for rationale and options.

// XXX doc

#ifndef _NXD_WCFS_H_
#define _NXD_WCFS_H_

#include <string>
using std::string;

#include <tuple>
using std::tuple;

#include <utility>
using std::pair;

#include "wcfs_misc.h"

struct _Conn;
class _WatchLink;


// WCFS represents filesystem-level connection to wcfs server.
// XXX doc
struct WCFS {
    string  mountpoint;

    tuple<refptr<_Conn>, error>         connect(zodb::Tid at);
    string                              _path(const string &obj);
    tuple<os::File, error>              _open(const string &path, int flags=O_RDONLY);
    pair<refptr<_WatchLink>, error>     _openwatch();
};


#endif
